;;;;;;;;;;;;;;;;;;;;;;;
;;; WARNING ACHTUNG ;;;
;;;                 ;;;
;;; ugly code below ;;;
;;; not for persons ;;;
;;; over 18 days of ;;;
;;; developing code ;;;
;;;    in Scheme    ;;;
;;;;;;;;;;;;;;;;;;;;;;;

(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-ltsconf")

;;;;;;;;;;;;;;;;;;;;;; unused
(define yes "theme:ltsconf/check.png")
(define no  "theme:ltsconf/cross.png")

(define x-mode-list
  '("default" "1024x768" "800x600"))

; key . defaultness -- since corresponding widget's value can be (non-)default
(define term-row-data (make-cell
  '((name . #t)
    (localdev . #t)
    (sound . #t)
    (x_mode_0 . #t)
    )))

; copycat from /vm/blonde
(define term-row-template
  `((name . ,(_ "Host"))
    (localdev . ,(_ "localdev"))
    (sound . ,(_ "sound"))
    (x_mode_0 . ,(_ "resolution"))
    ))

(define (row-values-ordered plist)	; mark all booleans with pretty checkmarks
  (define (yesno arg)
    (if (boolean? arg)
     (if arg `(#t . ,yes) `(#f . ,no))
     arg))
  (define (lookup-or-nil key)
    (yesno (cond-plistq key plist "default")))	; default should probably be '()
  (let ((props (map car term-row-template)))
    (map lookup-or-nil props)))

(define (make-term-rows)
  (let ((terms (woo-list-names "/ltsconf")))
    ; (#(ws245 #f #f #t) ... #(ws1 #f #t #f))
    (map
      (lambda (term)
	;(apply vector (woo-leaf-props (string-append "/ltsconf/" term) props))
	(apply vector 
	       ; (ws245 #t #f) --> ordered as per term-row-template
	       (row-values-ordered
		    ; (name ws245 sound #f localdev #t x_mode_0 "1024x768")
		    (cdr
			    ; (/ltsconf/ws245 name ws245 sound #f localdev #t x_mode_0 "1024x768")
			    (woo-read-first (string-append "/ltsconf/"
							   term))))))
      terms)))

(define (defaultness-ref name)
  ;(format #t "debug: defaultness-ref: ~S~%" name)
    (assv-ref (cell-ref term-row-data) name)
  )

(define (defaultness-set! name value)
  ;(format #t "debug: defaultness-set!: ~S~% => ~S~%\n" name value)
  (cell-set! term-row-data (assv-set! (cell-ref term-row-data) name value)))

(define (default! name) (defaultness-set! name #t))
(define (non-default! name) (defaultness-set! name #f))
(define (default? name) (defaultness-ref name))		; I know, I know...
(define (non-default? name) (not (defaultness-ref name)))

(define (def-tooltip name)
  (if (default? name) "default" ""))

; TODO: see /users for more elegant style
(document:id termlist
	     (listbox
	       columns (length term-row-template)
	       header (apply vector (map cdr term-row-template))
	       rows (make-term-rows)
	       (when selected (update-term (current-termlist) #t))))

(document:id term-settings
	     (gridbox columns "30;40;30"
		      (label (_ "Customize:") align "right")
		      (document:id edit-ws (edit "" activity #f
						 (when changed (check-name))))
		      (document:id rem-button (button (_ "Defaults") activity #f))

		      (label (_ "Local devices:") align "right")
		      (document:id check-localdev (checkbox "" activity #f tooltip ""
							    (when toggled (non-default! 'localdev))))
		      (spacer)

		      (label (_ "Sound:") align "right")
		      (document:id check-sound (checkbox "" activity #f tooltip ""
							 (when toggled (non-default! 'sound))))
		      (spacer)

		      (label (_ "Resolution") align "right")
		      (document:id list-resolution (combobox rows x-mode-list current 0
							     widget-name "list-resolution"
							     activity #f tooltip ""))
		      (spacer)))

(hbox align "center"
      (document:id c-button (button (_ "Apply")))
      (document:id r-button (button (_ "Reset")))
      (document:id q-button (button (_ "Quit"))))

;;;;;;;;;;;;;;;;;;;;;;

;;; behaviour
(c-button (when clicked (commit-term (current-termlist))))
(r-button (when clicked (update-term (current-termlist) #t)))
(q-button (when clicked (document:end)))

(rem-button (when clicked (remove-term (current-termlist))))

; custom means either present on the list or just modified
; achtung, this is not well thought out and may be flakey

; FIXME: rewrite plan: keep data separate from widgets; structure like:
; ("ws123" . ((hostname . "ws123") (sound . #t) (defsound . #t) (localdev . #t) (deflocaldev . #t)))

(define resolutions
  (map
    (lambda (x) (caar (vector->list x)))
    (list-resolution rows)))

(define (update-term name custom?)
  ((widgets check-localdev check-sound list-resolution) activity #t)
  ;;; TODO: still need to fix the whole "defaultness" mess before :-/
  ;(format #t "update-term: name=~S custom?=~S act=~S~%" name custom? (not (string=? "default" name)))
  (rem-button activity (not (string=? "default" name)))
  ;(format #t "update-term: custom?=~S~%" custom?)
  (and (not-empty-string? name)
       (defaultness-set! 'name (not custom?))
       (edit-ws text name)
       (let*
	 ((cmd (woo-read-first (string-append "/ltsconf/" name)))
	  (dfl (woo-read-first "/ltsconf/default"))
	  ; the following is *ugly*
	  (state-localdev (woo-get-option cmd 'localdev '()))
	  (state-sound (woo-get-option cmd 'sound '()))
	  (state-x_mode_0 (woo-get-option cmd 'x_mode_0 "default"))
	  (dfl-x_mode_0 (woo-get-option dfl 'x_mode_0 "default"))
	  )
	  ;(format #t "update-term: cmd: ~S~%" cmd)
	  ;(format #t "update-term: state-x_mode_0: ~S~%" state-x_mode_0)
	  ;(format #t "update-term: resolutions: ~S~%" resolutions)
	  ;(format #t "update-term: index: ~S~%" (string-list-index state-x_mode_0 (map car (list-resolution rows))))
	 (if (and custom?
		  (not (or (empty-string? state-x_mode_0)
			   (string=? "default" state-x_mode_0))))
	   (begin
	     (non-default! 'x_mode_0)
	     ;(format #t "update-term: non-default x_mode_0\n")
	     (list-resolution current (or (string-list-index state-x_mode_0 resolutions) 0)
			      tooltip (def-tooltip 'x_mode_0)
			      ;text (def-tooltip 'x_mode_0)
			      ))
	   (begin
	     ;(format #t "update-term: default x_mode_0\n")
	     (default! 'x_mode_0)
	     (list-resolution current 0
			      tooltip (def-tooltip 'x_mode_0)
			      ;text (def-tooltip 'localdev)
			      )))
	 (if (and custom? (boolean? state-localdev))
	   (begin
	     (non-default! 'localdev)
	     ;(format #t "update-term: non-default localdev\n")
	     (check-localdev state state-localdev
			     tooltip (def-tooltip 'localdev)
			     text (def-tooltip 'localdev)))
	   (begin
	     ;(format #t "update-term: default localdev\n")
	     (default! 'localdev)
	     (check-localdev state (woo-get-option dfl 'localdev)
			     tooltip (def-tooltip 'localdev)
			     text (def-tooltip 'localdev))))
	 (if (and custom? (boolean? state-sound))
	   (begin
	     (non-default! 'sound)
	     ;(format #t "update-term: non-default sound [~S]\n" (def-tooltip 'sound))
	     (check-sound state state-sound
			  tooltip (def-tooltip 'sound)
			  text (def-tooltip 'sound)))
	   (begin
	     ;(format #t "update-term: default sound [~S]\n" (def-tooltip 'sound))
	     (default! 'sound)
	     (check-sound state (woo-get-option dfl 'sound)
			  tooltip (def-tooltip 'sound)
			  text (def-tooltip 'sound))))))
  ;(format #t "update-term: exiting...~%")
  )

(define (update-termlist)
  (let* ((cur (termlist current)))
    (termlist rows (make-term-rows))
    ;(format #t "update-termlist: ~S / ~S~%" cur (termlist count))
    (termlist current (if (< cur (termlist count)) cur 0))))	; NB: count might have changed after deletion, take latest

(define (commit-term name)
  ;(format #t "commit-term: term-row-data: ~S~%" (cell-ref term-row-data))
  (if (not-empty-string? name)
    (let ((resolution (list-resolution text)))
      ;(format #t "commit-term: resolution: ~S~%" resolution)
      ;(format #t "commit-term: non-default?: ~S~%" (non-default? 'x_mode_0))
      ; our backend will silently drop parameters with empty values (and drop keys)
      (woo-write (string-append "/ltsconf/" name)
		 'localdev (if (non-default? 'localdev) (check-localdev state) "")
		 'sound (if (non-default? 'sound) (check-sound state) "")
		 'x_mode_0 (if (string=? "default" resolution) "" resolution)
		 )
      ; updating listbox directly might be faster but less bulletproof
      (update-termlist)
      ;(format #t "non-default: ~S~%" (non-default? name))
      (update-term name (non-default? name)))))

(define (current-termlist)	; "ws245"
  (let 
    ((cur (termlist current))
     (count (termlist count)))
    ;(format #t "current-termlist: ~S / ~S~%" cur count)	; 2 / 3
    (if (number? cur)
      (begin
       ;(format #t "current-termlist: ~S~%" cur)
       (car
	 (vector-ref
	   (list-ref
	     (termlist rows)
	     (if (and	; watch out for out-of-bounds when deleting last row
		   (> cur -1)
		   (< cur count))
	       cur
	       (- count 1)))
	   0))))))

; seems like a bug/misfeature in qtbrowser:
; after remove, listbox will return current as -1
; even if there will be some row selected
(define (remove-term name)
  (let ((cur (termlist current)))	; FIXME: unneeded
  (and
    name
    (begin
      (woo-delete (string-append "/ltsconf/" name))
      (update-termlist)
      (update-term (current-termlist) #f)))))

